SystemOrganization addCategory: #SqueakSVNPlugins!

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 2/27/2008 00:57'!
convertCStringToOop: aCString
	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| len newString |
	self var: 'aCString' type: 'const char *'.
	len := self strlen: aCString.
	newString := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: len.
	self st: (interpreterProxy arrayValueOf: newString)
		rn: aCString
		cpy: len. "(char *)strncpy()"
	^ newString! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rt 2/11/2008 13:38'!
convertOopToCString: anOop
	"This method converts an oop to a c sting.
	Free the result !!!!!!"

	| lengthOfOop tmpString resultString |
	self export: false.
	self returnTypeC: 'char*'.
	self var: #tmpString declareC: 'char* tmpString'.
	self var: #resultString declareC: 'char* resultString'.
		
	lengthOfOop := interpreterProxy slotSizeOf: anOop.
	tmpString := interpreterProxy firstIndexableField: anOop.
	self cCode: 'resultString = (char*) malloc(lengthOfOop + 1)'.

	"converting"
	0 to: lengthOfOop - 1 do: [:indexOfChar |
		resultString at: indexOfChar put: (tmpString at: indexOfChar)].
	self cCode: 'resultString[lengthOfOop] = ''\0'''.
	
	self cCode: 'return resultString'! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/12/2008 13:25'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/21/2008 13:16'!
svnAdd: targetOop

	| target |
	self export: true.
	self var: #target declareC: 'char *target'.
	self primitive: 'svnAdd' parameters: #(Oop ).
	
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'addTargetToWC (target)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	^targetOop! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'pe 2/21/2008 13:06'!
svnAddProperty: propertyOop WithValue:valueOop To: targetOop

	| property value target |
	self export: true.
	self var: #property declareC: 'char *property'.
	self var: #value declareC: 'char *value'.
	self var: #target declareC: 'char *target'.
	self primitive: 'svnAddPropertyWithValueTo' parameters: #(Oop Oop Oop).
	
	property := self convertOopToCString: propertyOop.
	value := self convertOopToCString: valueOop.
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'addPropertyAndValueToTarget (property, value, target)'.
	
	self cCode: 'free(property)'.
	self cCode: 'free(value)'.
	self cCode: 'free(target)'.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/21/2008 13:41'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop

	| url path |
	self export: true.
	self var: #url declareC: 'char* url'.
	self var: #path declareC: 'char* path'.
	self primitive: 'svnCheckoutHeadRevisionFromTo' parameters: #(Oop Oop ).
	
	url := self convertOopToCString: aURLOop.
	path := self convertOopToCString: aPathOop.
	
	"Call SVNWrapper function"
	self cCode: 'checkoutHeadRevisionFormTo(url, path)'.
	
	self cCode: 'free(url)'.
	self cCode: 'free(path)'! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/21/2008 15:06'!
svnCheckoutRevisionByNumber: aNumberOop from: aURLOop to: aPathOop

	| revisionNumber url path |
	self export: true.
	self var: #revisionNumber declareC: 'long int revisionNumber'.
	self var: #url declareC: 'char* url'.
	self var: #path declareC: 'char* path'.
	self primitive: 'svnCheckoutRevisionByNumberFromTo' parameters: #(Integer Oop Oop ).
	
	"self cCode: 'revisionNumber = (long int) aNumberOop'."
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	url := self convertOopToCString: aURLOop.
	path := self convertOopToCString: aPathOop.
	
	"Call SVNWrapper function"
	self cCode: 'checkoutRevisionByNumberFormTo(revisionNumber, url, path)'.
	
	self cCode: 'free(url)'.
	self cCode: 'free(path)'! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'pe 3/5/2008 11:56'!
svnCommit: aOopCollectionOfOopTargets WithMessage: aOopMessage

	| targetsArray squeakStrings count cString message |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self var: #message declareC: 'char* message'.
	self primitive: 'svnCommitWithMessage' parameters: #(Oop Oop).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	message := self convertOopToCString: aOopMessage.
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'commit( count, targetsArray, message)'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.
	self cCode: 'free( message )'.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 3/10/2008 17:28'!
svnDeleteTargetsFromWorkingCopy: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self primitive: 'svnDeleteTargetsFromWorkingCopy' parameters: #(Oop).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'deleteTargetsFromWC( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.
	
	^aOopCollectionOfOopTargets! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'cop 3/11/2008 21:53'!
svnGetBlameLinesFrom: targetOop
	"returns an array like #(rev1 author1 date1 line1 ...)"
	
	| target cArray arrayOop ptr numberOfLines |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #cArray declareC: 'char **cArray'.
	self var: #numberOfLines declareC: 'int numberOfLines'.
	self var: #ptr declareC: 'int *ptr'.
	self primitive: 'svnGetBlameLinesFrom' parameters: #(Oop).
	
	target := self convertOopToCString: targetOop.
	
	"get the filled array"
	self cCode: 'getBlameLines(target, &numberOfLines, &cArray)'.

	"Create a Squeak-Array in which the result can be returned"
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: numberOfLines.
	
	"Copy the entries into the Squeak-Array and free them"
	ptr := interpreterProxy firstIndexableField: arrayOop.
	0 to: numberOfLines - 1 do: [:i |
		ptr at: i put: (self convertCStringToOop: (cArray at: i)).
		self free: (cArray at: i)].
	self free: cArray.
	
	^ arrayOop.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/11/2008 14:18'!
svnGetHeadRevision: targetOop

	| target revision |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #revision declareC: 'int revision'.
	self primitive: 'svnGetHeadRevision' parameters: #(Oop ).
	
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'getHeadRevisionOf(target, &revision)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	"interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: revision)."
	^interpreterProxy integerObjectOf: revision! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rkrk 2/27/2008 02:11'!
svnGetPropertiesFrom: targetOop
	"returns an array like #(key1 value1 key2 value2 ...)"
	
	| target numberOfAllProperties keyAndValueArray arrayOop ptr |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #keyAndValueArray declareC: 'char **keyAndValueArray'.
	self var: #numberOfAllProperties declareC: 'int numberOfAllProperties'.
	self var: #ptr declareC: 'int *ptr'.
	self primitive: 'svnGetPropertiesFrom' parameters: #(Oop).
	
	"Create an arrays for keys and for values and pass it to the wrapper.
	It will fill the array with keys at unequal and the values at equal indices"
	target := self convertOopToCString: targetOop.
	numberOfAllProperties := 0.
	self cCode: 'numberOfProperties(target, &numberOfAllProperties)'.

	"Create a Squeak-Array in which the result can be returned"
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: numberOfAllProperties*2.

	"if there are no properties, go home"
	(numberOfAllProperties > 0) ifFalse: [^ arrayOop].
	
	"get the keys and values"
	keyAndValueArray := self cCode: '(char**) malloc(sizeof(char*)*numberOfAllProperties*2)'.
	self cCode: 'propertyKeyAndValues(target, &keyAndValueArray)'.
	
	"Copy the entries into the Squeak-Array and free them"
	ptr := interpreterProxy firstIndexableField: arrayOop.
	0 to: numberOfAllProperties* 2 - 1 do: [:i |
		ptr at: i put: (self convertCStringToOop: (keyAndValueArray at: i)).
		self free: (keyAndValueArray at: i)].
	self free: keyAndValueArray.
	
	^ arrayOop.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/21/2008 15:10'!
svnUpdateTargets: aOopCollectionOfOopTargets toRevisionByNumber: aNumberOop

	| targetsArray squeakStrings count cString revisionNumber |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self var: #revisionNumber declareC: 'long int revisionNumber'.
	self primitive: 'svnUpdateTargetsToRevisionByNumber:' parameters: #(Oop Integer ).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"self cCode: 'revisionNumber = (long int) aNumberOop'."
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToRevisionByNumber( count, targetsArray , revisionNumber )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/21/2008 13:37'!
svnUpdateTargetsToHeadRevision: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self primitive: 'svnUpdateTargetsToHeadRevision' parameters: #(Oop ).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToHeadRevision( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !
